Index: issm/trunk/src/c/classes/FemModel.cpp
===================================================================
--- issm/trunk/src/c/classes/FemModel.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/FemModel.cpp	(revision 26744)
@@ -14,4 +14,5 @@
 #include "../shared/io/io.h"
 #include "./classes.h"
+#include "./Inputs/TriaInput.h"
 #include "./modules/modules.h"
 #include "../shared/Enum/Enum.h"
@@ -243,5 +244,4 @@
 	_error_("Could not find index of analysis " << EnumToStringx(analysis_enum) << " in list of FemModel analyses");
 
-
 }/*}}}*/
 void FemModel::CheckPoint(void){/*{{{*/
@@ -821,8 +821,4 @@
 			break;
 
-		case GiaSolutionEnum:
-			analyses_temp[numanalyses++]=GiaAnalysisEnum;
-			break;
-
 		case LoveSolutionEnum:
 			analyses_temp[numanalyses++]=LoveAnalysisEnum;
@@ -833,7 +829,6 @@
 			break;
 
-		case SealevelriseSolutionEnum:
-			analyses_temp[numanalyses++]=SealevelriseAnalysisEnum;
-			analyses_temp[numanalyses++]=GiaAnalysisEnum;
+		case SamplingSolutionEnum:
+			analyses_temp[numanalyses++]=SamplingAnalysisEnum;
 			break;
 
@@ -848,8 +843,9 @@
 		case TransientSolutionEnum:{
 			/*We have multiple analyses here, process one by one*/
-			bool isSIA,isFS,isthermal,isenthalpy,ismasstransport,isgroundingline,isstressbalance,ismovingfront,ishydrology,isdamage,issmb,isslr,isesa,isgia;
+			bool isSIA,isFS,isthermal,isenthalpy,ismasstransport,isoceantransport,isgroundingline,isstressbalance,ismovingfront,ishydrology,isdamage,issmb,isslc,isesa,issampling;
 			iomodel->FindConstant(&isthermal,"md.transient.isthermal");
 			iomodel->FindConstant(&ismovingfront,"md.transient.ismovingfront");
 			iomodel->FindConstant(&ismasstransport,"md.transient.ismasstransport");
+			iomodel->FindConstant(&isoceantransport,"md.transient.isoceantransport");
 			iomodel->FindConstant(&isstressbalance,"md.transient.isstressbalance");
 			iomodel->FindConstant(&isgroundingline,"md.transient.isgroundingline");
@@ -857,9 +853,9 @@
 			iomodel->FindConstant(&ishydrology,"md.transient.ishydrology");
 			iomodel->FindConstant(&issmb,"md.transient.issmb");
-			iomodel->FindConstant(&isslr,"md.transient.isslr");
+			iomodel->FindConstant(&isslc,"md.transient.isslc");
 			iomodel->FindConstant(&isesa,"md.transient.isesa");
-			iomodel->FindConstant(&isgia,"md.transient.isgia");
-         int* analyses_iter     = NULL;
-         int  num_analyses_iter = 0;
+			iomodel->FindConstant(&issampling,"md.transient.issampling");
+      int* analyses_iter     = NULL;
+      int  num_analyses_iter = 0;
 			if(isstressbalance){
 				SolutionAnalysesList(&analyses_iter,&num_analyses_iter,iomodel,StressbalanceSolutionEnum);
@@ -897,13 +893,15 @@
 				analyses_temp[numanalyses++]=DamageEvolutionAnalysisEnum;
 			}
-			if(isslr){
-				analyses_temp[numanalyses++]=GiaAnalysisEnum;
-				analyses_temp[numanalyses++]=SealevelriseAnalysisEnum;
+			if(isoceantransport){
+				analyses_temp[numanalyses++]=OceantransportAnalysisEnum;
+			}
+			if(isslc){
+				analyses_temp[numanalyses++]=SealevelchangeAnalysisEnum;
 			}
 			if(isesa){
 				analyses_temp[numanalyses++]=EsaAnalysisEnum;
 			}
-			if(isgia){
-				analyses_temp[numanalyses++]=GiaAnalysisEnum;
+			if(issampling){
+				analyses_temp[numanalyses++]=SamplingAnalysisEnum;
 			}
 
@@ -986,5 +984,4 @@
 		if(profiler->Used(SMBCORE)) _printf0_("   "<<setw(40)<<left<<"SMB core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(SMBCORE) << " sec\n");
 		if(profiler->Used(GROUNDINGLINECORE)) _printf0_("   "<<setw(40)<<left<<"Groundingline migration core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(GROUNDINGLINECORE) << " sec\n");
-		if(profiler->Used(GIACORE)) _printf0_("   "<<setw(40)<<left<<"GIA core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(GIACORE) << " sec\n");
 		if(profiler->Used(ESACORE)) _printf0_("   "<<setw(40)<<left<<"ESA core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(ESACORE) << " sec\n");
 		if(profiler->Used(SLRCORE)) _printf0_("   "<<setw(40)<<left<<"SLR core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(SLRCORE) << " sec\n");
@@ -1177,5 +1174,5 @@
 		Element* basalelement = element->SpawnBasalElement();
 		basalelement->WriteFieldIsovalueSegment(segments,fieldenum,fieldvalue);
-		if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+		if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	}
 
@@ -1605,34 +1602,27 @@
 void FemModel::IcefrontAreax(){/*{{{*/
 
-	int numvertices      = 6;
-	int numbasins;
-	IssmDouble* BasinId   = xNew<IssmDouble>(numvertices);
+	int numbasins,BasinId;
 	this->parameters->FindParam(&numbasins,FrontalForcingsNumberofBasinsEnum);
-	IssmDouble* basin_icefront_area           = xNewZeroInit<IssmDouble>(numbasins);
-
-	for(int basin=1;basin<numbasins+1;basin++){
+	IssmDouble* basin_icefront_area = xNewZeroInit<IssmDouble>(numbasins);
+
+	for(int basin=0;basin<numbasins;basin++){
 		IssmDouble local_icefront_area = 0;
 		IssmDouble total_icefront_area;
 
+		/*Add contribution of each element to icefront area of the basin*/
 		for(Object* & object : this->elements->objects){
 			Element* element= xDynamicCast<Element*>(object);
-			element->GetInputListOnVertices(BasinId,FrontalForcingsBasinIdEnum);
-			for(int j=0;j<numvertices;j++){
-				if(BasinId[j]==basin){
-					local_icefront_area+=element->GetIcefrontArea();
-					break;
-				}
-			}
+			element->GetInputValue(&BasinId,FrontalForcingsBasinIdEnum);
+			if(BasinId==basin) local_icefront_area+=element->GetIcefrontArea();
 		}
 		ISSM_MPI_Reduce(&local_icefront_area,&total_icefront_area,1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm());
 		ISSM_MPI_Bcast(&total_icefront_area,1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
 
-		basin_icefront_area[basin-1]=total_icefront_area;
-	}
-
+		basin_icefront_area[basin]=total_icefront_area;
+	}
+	
 	this->parameters->AddObject(new DoubleVecParam(FrontalForcingsBasinIcefrontAreaEnum,basin_icefront_area,numbasins));
 
 	xDelete<IssmDouble>(basin_icefront_area);
-	xDelete<IssmDouble>(BasinId);
 }/*}}}*/
 void FemModel::IcefrontMassFluxx(IssmDouble* pM, bool scaled){/*{{{*/
@@ -2112,4 +2102,9 @@
 
 }/*}}}*/
+void FemModel::MmeToInputFromId(int id, int rootenum, int interpolationenum){ /*{{{*/
+
+	MmeToInputFromIdx(this->inputs,this->elements,id,rootenum,interpolationenum);
+
+}	//}}}
 void FemModel::OmegaAbsGradientx( IssmDouble* pJ){/*{{{*/
 
@@ -2304,5 +2299,11 @@
 
 			#if defined(_HAVE_CODIPACK_)
+			#if _CODIPACK_MAJOR_==2
+			auto& tape_codi = IssmDouble::getTape();
+			#elif _CODIPACK_MAJOR_==1
 			auto& tape_codi = IssmDouble::getGlobalTape();
+			#else
+			#error "_CODIPACK_MAJOR_ not supported"
+			#endif
 			#endif
 
@@ -2316,5 +2317,11 @@
 						tape_codi.registerOutput(output_value);
 						dependents[i] = output_value.getValue();
+						#if _CODIPACK_MAJOR_==2
+						codi_global.output_indices.push_back(output_value.getIdentifier());
+						#elif _CODIPACK_MAJOR_==1
 						codi_global.output_indices.push_back(output_value.getGradientData());
+						#else
+						#error "_CODIPACK_MAJOR_ not supported"
+						#endif
 					#else
 						output_value>>=dependents[i];
@@ -2352,5 +2359,4 @@
 	if(numonnodes) parameters->FindParam(&resultsonnodes,&numonnodes,SettingsResultsOnNodesEnum);
 
-
 	/*Go through all requested output*/
 	for(int i=0;i<numoutputs;i++){
@@ -2358,5 +2364,4 @@
 		output_enum   = StringToEnumx(output_string,false);
 		isvec         = false;
-
 
 		/*If string is not an enum, it is defined in output definitions*/
@@ -2478,5 +2483,4 @@
 					}
 					break;
-
 
 				   /*Default is always Vector */
@@ -3655,5 +3659,4 @@
 	}
 
-
 	/*Cleanup*/
 	xDelete<IssmDouble>(P0inputs);
@@ -4667,15 +4670,4 @@
 /*}}}*/
 #endif
-#ifdef _HAVE_GIA_
-void FemModel::Deflection(Vector<IssmDouble>* wg,Vector<IssmDouble>* dwgdt, IssmDouble* x, IssmDouble* y){ /*{{{*/
-
-	/*Go through elements, and add contribution from each element to the deflection vector wg:*/
-	for(Object* & object : this->elements->objects){
-		Element* element = xDynamicCast<Element*>(object);
-		element->GiaDeflection(wg,dwgdt, x,y);
-	}
-}
-/*}}}*/
-#endif
 #ifdef _HAVE_ESA_
 void FemModel::EsaGeodetic2D(Vector<IssmDouble>* pUp, Vector<IssmDouble>* pNorth, Vector<IssmDouble>* pEast, Vector<IssmDouble>* pX, Vector<IssmDouble>* pY, IssmDouble* xx, IssmDouble* yy){/*{{{*/
@@ -4753,341 +4745,4 @@
 	xDelete<IssmDouble>(yy);
 	xDelete<IssmDouble>(zz);
-}
-/*}}}*/
-#endif
-#ifdef _HAVE_SEALEVELRISE_
-void FemModel::SealevelriseEustatic(Vector<IssmDouble>* pRSLgi, IssmDouble* poceanarea, IssmDouble* pbslr,IssmDouble* pbslrice, IssmDouble* pbslrhydro, IssmDouble** pbslrice_partition,IssmDouble** pbslrhydro_partition,SealevelMasks* masks) { /*{{{*/
-
-	/*serialized vectors:*/
-	IssmDouble  bslrice       = 0.;
-	IssmDouble  bslrice_cpu   = 0.;
-	IssmDouble  bslrhydro       = 0.;
-	IssmDouble  bslrhydro_cpu   = 0.;
-	IssmDouble  area      = 0.;
-	IssmDouble  oceanarea      = 0.;
-	IssmDouble  oceanarea_cpu  = 0.;
-	int bp_compute_fingerprints= 0;
-
-	Vector<IssmDouble>* bslrice_partition=NULL;
-	IssmDouble* bslrice_partition_serial=NULL;
-	IssmDouble* partitionice=NULL;
-	int npartice,nel; 
-
-	Vector<IssmDouble>* bslrhydro_partition=NULL;
-	IssmDouble* bslrhydro_partition_serial=NULL;
-	IssmDouble* partitionhydro=NULL;
-	int nparthydro; 
-		
-
-   /*Initialize temporary vector that will be used to sum eustatic components
-    * on all local elements, prior to assembly:*/
-	int gsize = this->nodes->NumberOfDofs(GsetEnum);
-	IssmDouble* RSLgi=xNewZeroInit<IssmDouble>(gsize);
-	int* indices=xNew<int>(gsize);
-   for(int i=0;i<gsize;i++) indices[i]=i;
-
-	/*First, figure out the area of the ocean, which is needed to compute the eustatic component: */
-	int i = -1;
-	for(Object* & object : this->elements->objects){
-		i +=1;
-		Element* element = xDynamicCast<Element*>(object);
-		element->GetInputValue(&area,AreaEnum);
-		if (masks->isoceanin[i]) oceanarea_cpu += area;
-	}
-	ISSM_MPI_Reduce (&oceanarea_cpu,&oceanarea,1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
-	ISSM_MPI_Bcast(&oceanarea,1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
-	_assert_(oceanarea>0.);
-
-	/*Initialize partition vectors to retrieve barystatic contributions: */
-	this->parameters->FindParam(&npartice,SolidearthNpartIceEnum);
-	if(npartice){
-		this->parameters->FindParam(&partitionice,&nel,NULL,SolidearthPartitionIceEnum);
-		bslrice_partition= new Vector<IssmDouble>(npartice);
-	}
-
-	this->parameters->FindParam(&nparthydro,SolidearthNpartHydroEnum);
-	if(nparthydro){
-		this->parameters->FindParam(&partitionhydro,&nel,NULL,SolidearthPartitionHydroEnum);
-		bslrhydro_partition= new Vector<IssmDouble>(nparthydro);
-	}
-
-
-	/*Call the sea level rise core for ice : */
-	bslrice_cpu=0;
-	for(Object* & object : this->elements->objects){
-		Element* element = xDynamicCast<Element*>(object);
-		bslrice_cpu+=element->SealevelriseEustaticIce(RSLgi,masks, bslrice_partition,partitionice,oceanarea);
-	}
-
-	/*Call the sea level rise core for hydro: */
-	bslrhydro_cpu=0;
-	for(int i=0;i<elements->Size();i++){
-		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
-		bslrhydro_cpu+=element->SealevelriseEustaticHydro(RSLgi,masks, bslrhydro_partition,partitionhydro,oceanarea);
-	}
-
-	/*Call the sea level rise core for bottom pressures: */
-	this->parameters->FindParam(&bp_compute_fingerprints,DslComputeFingerprintsEnum);
-	if(bp_compute_fingerprints){
-		for(int i=0;i<elements->Size();i++){
-			Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
-			element->SealevelriseEustaticBottomPressure(RSLgi,masks);
-		}
-	}
-
-	/*Plug values once and assemble: */
-	pRSLgi->SetValues(gsize,indices,RSLgi,ADD_VAL);
-	pRSLgi->Assemble();
-
-	/*Sum all eustatic components from all cpus:*/
-	ISSM_MPI_Reduce (&bslrice_cpu,&bslrice,1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
-	ISSM_MPI_Bcast(&bslrice,1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
-	_assert_(!xIsNan<IssmDouble>(bslrice));
-
-	ISSM_MPI_Reduce (&bslrhydro_cpu,&bslrhydro,1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
-	ISSM_MPI_Bcast(&bslrhydro,1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
-	_assert_(!xIsNan<IssmDouble>(bslrhydro));
-
-	/*Take care of partition vectors:*/
-	if(bslrice_partition){
-		bslrice_partition->Assemble();
-		bslrice_partition_serial=bslrice_partition->ToMPISerial();
-	}
-	if(bslrhydro_partition){
-		bslrhydro_partition->Assemble();
-		bslrhydro_partition_serial=bslrhydro_partition->ToMPISerial();
-	}
-
-
-	/*Free ressources:*/
-	xDelete<int>(indices);
-	xDelete<IssmDouble>(RSLgi);
-	if(bslrhydro_partition)delete bslrhydro_partition;
-	if(bslrice_partition)delete bslrice_partition;
-	if(partitionhydro)xDelete<IssmDouble>(partitionhydro);
-	if(partitionice)xDelete<IssmDouble>(partitionice);
-
-	/*Assign output pointers:*/
-	*poceanarea = oceanarea;
-	*pbslrice  = bslrice;
-	*pbslrhydro  = bslrhydro;
-	*pbslr=bslrhydro+bslrice;
-	*pbslrice_partition=bslrice_partition_serial;
-	*pbslrhydro_partition=bslrhydro_partition_serial;
-
-}
-/*}}}*/
-void FemModel::SealevelriseNonEustatic(Vector<IssmDouble>* pRSLgo, Vector<IssmDouble>* pRSLg_old,  SealevelMasks* masks, bool verboseconvolution){/*{{{*/
-
-	/*serialized vectors:*/
-	IssmDouble* RSLg_old=NULL;
-
-	IssmDouble* RSLgo  = NULL;
-	int* indices = NULL;
-	int         gsize;
-
-	bool computerigid = true;
-	bool computeelastic= true;
-
-	/*recover computational flags: */
-	this->parameters->FindParam(&computerigid,SolidearthSettingsRigidEnum);
-
-	/*Initialize temporary vector that will be used to sum eustatic components on all local elements, prior
-	 * to assembly:*/
-	gsize = this->nodes->NumberOfDofs(GsetEnum);
-	RSLgo=xNewZeroInit<IssmDouble>(gsize);
-	indices=xNew<int>(gsize); for (int i=0;i<gsize;i++)indices[i]=i;
-
-	/*Serialize vectors from previous iteration:*/
-	RSLg_old=pRSLg_old->ToMPISerial();
-
-	/*Call the sea level rise non-eustatic core only if required: */
-	if(computerigid){
-		for(Object* & object : this->elements->objects){
-			Element* element = xDynamicCast<Element*>(object);
-			element->SealevelriseNonEustatic(RSLgo,RSLg_old,masks);
-		}
-	}
-	pRSLgo->SetValues(gsize,indices,RSLgo,ADD_VAL);
-	pRSLgo->Assemble();
-
-	/*Free ressources:*/
-	xDelete<int>(indices);
-	xDelete<IssmDouble>(RSLgo);
-	xDelete<IssmDouble>(RSLg_old);
-
-}
-/*}}}*/
-void FemModel::SealevelriseRotationalFeedback(Vector<IssmDouble>* pRSLgo_rot, Vector<IssmDouble>* pRSLg_old, IssmDouble* pIxz, IssmDouble* pIyz, IssmDouble* pIzz,  SealevelMasks* masks){/*{{{*/
-
-	/*serialized vectors:*/
-	bool spherical=true;
-	IssmDouble* RSLg_old=NULL;
-	IssmDouble*	tide_love_h  = NULL;
-	IssmDouble*	tide_love_k  = NULL;
-	IssmDouble*	load_love_k  = NULL;
-	IssmDouble  tide_love_k2secular;
-	IssmDouble  moi_e, moi_p, omega, g;
-	IssmDouble	m1, m2, m3;
-	IssmDouble	lati, longi, radi, value;
-	IssmDouble          *latitude    = NULL;
-	IssmDouble          *longitude    = NULL;
-	IssmDouble          *radius    = NULL;
-
-	/*Serialize vectors from previous iteration:*/
-	RSLg_old=pRSLg_old->ToMPISerial();
-
-	IssmDouble moi_list[3]={0,0,0};
-	IssmDouble moi_list_cpu[3]={0,0,0};
-	for(Object* & object : this->elements->objects){
-		Element* element = xDynamicCast<Element*>(object);
-		element->SealevelriseMomentOfInertia(&moi_list[0],RSLg_old,masks );
-		moi_list_cpu[0] += moi_list[0];
-		moi_list_cpu[1] += moi_list[1];
-		moi_list_cpu[2] += moi_list[2];
-	}
-	ISSM_MPI_Reduce (&moi_list_cpu[0],&moi_list[0],1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
-	ISSM_MPI_Bcast(&moi_list[0],1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
-	//
-	ISSM_MPI_Reduce (&moi_list_cpu[1],&moi_list[1],1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
-	ISSM_MPI_Bcast(&moi_list[1],1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
-	//
-	ISSM_MPI_Reduce (&moi_list_cpu[2],&moi_list[2],1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
-	ISSM_MPI_Bcast(&moi_list[2],1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
-
-	/*pull out some useful parameters: */
-	parameters->FindParam(&load_love_k,NULL,NULL,LoadLoveKEnum);
-	parameters->FindParam(&tide_love_h,NULL,NULL,TidalLoveHEnum);
-	parameters->FindParam(&tide_love_k,NULL,NULL,TidalLoveKEnum);
-	parameters->FindParam(&tide_love_k2secular,TidalLoveK2SecularEnum);
-	parameters->FindParam(&moi_e,RotationalEquatorialMoiEnum);
-	parameters->FindParam(&moi_p,RotationalPolarMoiEnum);
-	parameters->FindParam(&omega,RotationalAngularVelocityEnum);
-
-	/*compute perturbation terms for angular velocity vector: */
-	m1 = 1/(1-tide_love_k[2]/tide_love_k2secular) * (1+load_love_k[2])/(moi_p-moi_e) * moi_list[0];
-	m2 = 1/(1-tide_love_k[2]/tide_love_k2secular) * (1+load_love_k[2])/(moi_p-moi_e) * moi_list[1];
-	m3 = -(1+load_love_k[2])/moi_p * moi_list[2];	// term associated with fluid number (3-order-of-magnitude smaller) is negelected
-
-	/*recover lat,long and radius vectors from vertices: */
-	VertexCoordinatesx(&latitude,&longitude,&radius,this->vertices,spherical);
-
-	/* Green's function (1+k_2-h_2/g): checked against Glenn Milne's thesis Chapter 3 (eqs: 3.3-4, 3.10-11)
-	 * Perturbation terms for angular velocity vector (m1, m2, m3): checked against Mitrovica (2005 Appendix) & Jensen et al (2013 Appendix A3)
-	 * Sea level rotational feedback: checked against GMD eqs 8-9 (only first order terms, i.e., degree 2 order 0 & 1 considered)
-	 * all DONE in Geographic coordinates: theta \in [-90,90], lambda \in [-180 180]
-	 */
-	for(Object* & object : vertices->objects){
-		Vertex* vertex=xDynamicCast<Vertex*>(object);
-		int sid=vertex->Sid();
-
-		lati=latitude[sid]/180*PI;
-		longi=longitude[sid]/180*PI;
-		radi=radius[sid];
-
-		/*only first order terms are considered now: */
-		value=((1.0+tide_love_k[2]-tide_love_h[2])/9.81)*pow(omega*radi,2.0)*
-						(-m3/6.0 + 0.5*m3*cos(2.0*lati) - 0.5*sin(2.*lati)*(m1*cos(longi)+m2*sin(longi)));
-
-		pRSLgo_rot->SetValue(sid,value,INS_VAL); //INS_VAL ensures that you don't add several times
-	}
-
-	/*Assemble mesh velocity*/
-	pRSLgo_rot->Assemble();
-
-	/*Assign output pointers:*/
-	if(pIxz)*pIxz=moi_list[0];
-	if(pIyz)*pIyz=moi_list[1];
-	if(pIzz)*pIzz=moi_list[2];
-	xDelete<IssmDouble>(latitude);
-	xDelete<IssmDouble>(longitude);
-	xDelete<IssmDouble>(tide_love_h);
-	xDelete<IssmDouble>(tide_love_k);
-	xDelete<IssmDouble>(load_love_k);
-
-	xDelete<IssmDouble>(radius);
-
-	/*Free ressources:*/
-	xDelete<IssmDouble>(RSLg_old);
-
-}
-/*}}}*/
-void FemModel::SealevelriseElastic(Vector<IssmDouble>* pUp, Vector<IssmDouble>* pNorth, Vector<IssmDouble>* pEast, Vector<IssmDouble>* pRSLg, SealevelMasks* masks){/*{{{*/
-
-	/*serialized vectors:*/
-	IssmDouble* RSLg=NULL;
-
-	IssmDouble* Up  = NULL;
-	IssmDouble* North  = NULL;
-	IssmDouble* East  = NULL;
-	int* indices = NULL;
-	int  gsize;
-	int  horiz;
-
-	/*retrieve parameters:*/
-	this->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
-
-	/*Serialize vectors from previous iteration:*/
-	RSLg=pRSLg->ToMPISerial();
-
-	/*Initialize temporary vector that will be used to sum eustatic components on all local elements, prior
-	 * to assembly:*/
-	gsize = this->nodes->NumberOfDofs(GsetEnum);
-	Up=xNewZeroInit<IssmDouble>(gsize);
-	if(horiz){
-		North=xNewZeroInit<IssmDouble>(gsize);
-		East=xNewZeroInit<IssmDouble>(gsize);
-	}
-	indices=xNew<int>(gsize); for (int i=0;i<gsize;i++)indices[i]=i;
-
-	/*Call the sea level rise core: */
-	for(Object* & object : this->elements->objects){
-		Element* element = xDynamicCast<Element*>(object);
-		element->SealevelriseGeodetic(Up,North,East,RSLg,masks);
-	}
-
-	pUp->SetValues(gsize,indices,Up,ADD_VAL);
-	pUp->Assemble();
-	if (horiz){
-		pNorth->SetValues(gsize,indices,North,ADD_VAL);
-		pNorth->Assemble();
-		pEast->SetValues(gsize,indices,East,ADD_VAL);
-		pEast->Assemble();
-	}
-
-	/*Free ressources:*/
-	xDelete<IssmDouble>(Up);
-	if(horiz){
-		xDelete<IssmDouble>(North);
-		xDelete<IssmDouble>(East);
-	}
-	xDelete<int>(indices);
-	xDelete<IssmDouble>(RSLg);
-}
-/*}}}*/
-IssmDouble FemModel::SealevelriseOceanAverage(Vector<IssmDouble>* RSLg,SealevelMasks* masks, IssmDouble oceanarea) { /*{{{*/
-
-	IssmDouble* RSLg_serial=NULL;
-	IssmDouble  oceanvalue,oceanvalue_cpu;
-
-	/*Serialize vectors from previous iteration:*/
-	RSLg_serial=RSLg->ToMPISerial();
-
-	/*Initialize:*/
-	oceanvalue_cpu=0;
-
-	/*Go through elements, and add contribution from each element and divide by overall ocean area:*/
-	for(Object* & object : this->elements->objects){
-		Element* element = xDynamicCast<Element*>(object);
-		oceanvalue_cpu += element->OceanAverage(RSLg_serial,masks);
-	}
-
-	ISSM_MPI_Reduce (&oceanvalue_cpu,&oceanvalue,1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
-	ISSM_MPI_Bcast(&oceanvalue,1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
-
-	/*Free ressources:*/
-	xDelete<IssmDouble>(RSLg_serial);
-
-	return oceanvalue/oceanarea;
 }
 /*}}}*/
@@ -5157,5 +4812,4 @@
 	serial_active=active->ToMPISerial();
 	delete active;
-
 
 	/*Update node activation accordingly*/
@@ -5193,8 +4847,5 @@
 		}
 		xDelete<IssmDouble>(base);
-		if(domaintype!=Domain2DhorizontalEnum){
-			basalelement->DeleteMaterials();
-			delete basalelement;
-		}
+		if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	}
 	xDelete<IssmDouble>(serial_active);
@@ -5795,5 +5446,4 @@
 	bool refine;
 
-
 	/*Fill variables*/
 	switch(errorestimator_type){
@@ -5883,5 +5533,4 @@
 
 	//itapopo esse metodo pode ser deletado
-
 
 	/*Here, "zero level set" means grounding line or ice front, depending on the level set type*/
Index: issm/trunk/src/c/classes/FemModel.h
===================================================================
--- issm/trunk/src/c/classes/FemModel.h	(revision 25994)
+++ issm/trunk/src/c/classes/FemModel.h	(revision 26744)
@@ -130,4 +130,5 @@
 		void MinVyx(IssmDouble* presponse);
 		void MinVzx(IssmDouble* presponse);
+		void MmeToInputFromId(int id, int rootenum, int interpolationenum);
 		void DistanceToFieldValue(int fieldenum,IssmDouble fieldvalue,int distanceenum);
 		void ResetLevelset();
@@ -158,17 +159,7 @@
 		void ThicknessAbsGradientx( IssmDouble* pJ);
 		void ThicknessPositivex(IssmDouble* pJ);
-		#ifdef _HAVE_GIA_
-		void Deflection(Vector<IssmDouble>* wg,Vector<IssmDouble>* dwgdt, IssmDouble* x, IssmDouble* y);
-		#endif
 		#ifdef _HAVE_ESA_
 		void EsaGeodetic2D(Vector<IssmDouble>* pUp, Vector<IssmDouble>* pNorth, Vector<IssmDouble>* pEast, Vector<IssmDouble>* pX, Vector<IssmDouble>* pY, IssmDouble* xx, IssmDouble* yy);
 		void EsaGeodetic3D(Vector<IssmDouble>* pUp, Vector<IssmDouble>* pNorth, Vector<IssmDouble>* pEast, IssmDouble* latitude, IssmDouble* longitude, IssmDouble* radius, IssmDouble* xx, IssmDouble* yy, IssmDouble* zz);
-		#endif
-		#ifdef _HAVE_SEALEVELRISE_
-		void SealevelriseEustatic(Vector<IssmDouble>* pRSLgi, IssmDouble* poceanarea, IssmDouble* pbslr,IssmDouble* pbslrice, IssmDouble* pbslrhydro, IssmDouble** pbslrice_partition,IssmDouble** pbslrhydro_partition, SealevelMasks* masks); 
-		void SealevelriseNonEustatic(Vector<IssmDouble>* pSgo, Vector<IssmDouble>* pSg_old,  SealevelMasks* masks,bool verboseconvolution);
-		void SealevelriseRotationalFeedback(Vector<IssmDouble>* pRSLgo_rot, Vector<IssmDouble>* pRSLg_old, IssmDouble* pIxz, IssmDouble* pIyz, IssmDouble* pIzz, SealevelMasks* masks);
-		void SealevelriseElastic(Vector<IssmDouble>* pUp, Vector<IssmDouble>* pNorth, Vector<IssmDouble>* pEast, Vector<IssmDouble>* pSg_old, SealevelMasks* masks);
-		IssmDouble SealevelriseOceanAverage(Vector<IssmDouble>* Sg,SealevelMasks* masks, IssmDouble oceanarea);
 		#endif
 		void HydrologyEPLupdateDomainx(IssmDouble* pEplcount);
Index: issm/trunk/src/c/classes/GrdLoads.cpp
===================================================================
--- issm/trunk/src/c/classes/GrdLoads.cpp	(revision 26744)
+++ issm/trunk/src/c/classes/GrdLoads.cpp	(revision 26744)
@@ -0,0 +1,69 @@
+/*
+ * \file GrdLoads.cpp
+ * \brief: Implementation of GrdLoads class
+ */
+
+/*Headers: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./GrdLoads.h"
+#include "./SealevelGeometry.h"
+using namespace std;
+/*}}}*/
+
+/*Object constructors and destructor*/
+GrdLoads::GrdLoads(int nel,SealevelGeometry* slgeom){ /*{{{*/
+
+	vloads=new Vector<IssmDouble>(nel);
+	for (int i=0;i<SLGEOM_NUMLOADS;i++) vsubloads[i]=new Vector<IssmDouble>(slgeom->nbar[i]);
+
+	vsealevelloads=new Vector<IssmDouble>(nel);
+	vsealevelloads->Set(0);vsealevelloads->Assemble();
+
+	vsubsealevelloads=new Vector<IssmDouble>(slgeom->nbar[SLGEOM_OCEAN]);
+
+}; /*}}}*/
+GrdLoads::~GrdLoads(){ /*{{{*/
+
+	delete vloads;
+	xDelete<IssmDouble>(loads);
+	for(int i=0;i<SLGEOM_NUMLOADS;i++){
+		delete vsubloads[i];
+		xDelete<IssmDouble>(subloads[i]);
+	}
+	delete vsealevelloads;
+	xDelete<IssmDouble>(sealevelloads);
+	delete vsubsealevelloads;
+	xDelete<IssmDouble>(subsealevelloads);
+}; /*}}}*/
+
+void GrdLoads::BroadcastLoads(void){ /*{{{*/
+
+	/*Initialize barycentre vectors, now that we know their size: */
+	vloads->Assemble();
+	for (int i=0;i<SLGEOM_NUMLOADS;i++){
+		vsubloads[i]->Assemble();
+	}
+
+	loads=vloads->ToMPISerial();
+	for (int i=0;i<SLGEOM_NUMLOADS;i++){
+		subloads[i]=vsubloads[i]->ToMPISerial();
+	}
+
+} /*}}}*/
+void GrdLoads::AssembleSealevelLoads(void){ /*{{{*/
+
+	vsealevelloads->Assemble();
+	vsubsealevelloads->Assemble();
+
+} /*}}}*/
+void GrdLoads::BroadcastSealevelLoads(void){ /*{{{*/
+
+	sealevelloads=vsealevelloads->ToMPISerial();
+	subsealevelloads=vsubsealevelloads->ToMPISerial();
+
+} /*}}}*/
Index: issm/trunk/src/c/classes/GrdLoads.h
===================================================================
--- issm/trunk/src/c/classes/GrdLoads.h	(revision 26744)
+++ issm/trunk/src/c/classes/GrdLoads.h	(revision 26744)
@@ -0,0 +1,32 @@
+/*!\file GrdLoads.h
+ * \brief: header file for GrdLoads
+ */
+
+#ifndef _SEALEVELGRDLOADS_H_
+#define _SEALEVELGRDLOADS_H_
+
+/*Headers:*/
+#include "./SealevelGeometry.h"
+#include "../toolkits/toolkits.h"
+
+class GrdLoads{ 
+
+	public: 
+
+		Vector<IssmDouble>* vloads=NULL;
+		IssmDouble*         loads=NULL;
+		Vector<IssmDouble>* vsubloads[SLGEOM_NUMLOADS];
+		IssmDouble*         subloads[SLGEOM_NUMLOADS];
+		Vector<IssmDouble>* vsealevelloads=NULL;
+		IssmDouble*         sealevelloads=NULL;
+		Vector<IssmDouble>* vsubsealevelloads=NULL;
+		IssmDouble*         subsealevelloads=NULL;
+
+		GrdLoads(int nel, SealevelGeometry* slgeom);
+		~GrdLoads();
+
+		void AssembleSealevelLoads(void);
+		void BroadcastLoads(void);
+		void BroadcastSealevelLoads(void);
+};
+#endif  /* _SEALEVELGRDLOADS_H_ */
Index: issm/trunk/src/c/classes/Inputs/ControlInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/ControlInput.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Inputs/ControlInput.cpp	(revision 26744)
@@ -223,5 +223,4 @@
 	//}
 
-
 	//NEW??
 	//this->gradient->SetInput(interp,numindices,indices,values_in);
@@ -282,5 +281,5 @@
 	else{
 		int* temp = xNew<int>(3);
-		_error_("not supported");
+		_error_("Gradient is of type "<<EnumToStringx(this->gradient->ObjectEnum()) <<", which is not supported yet");
 	}
 
Index: issm/trunk/src/c/classes/Inputs/DatasetInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/DatasetInput.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Inputs/DatasetInput.cpp	(revision 26744)
@@ -90,7 +90,50 @@
 	marshallhandle->call(this->numberofvertices_local);
 	marshallhandle->call(this->ids,numids);
-	//if (marshallhandle->OperationNumber() == MARSHALLING_LOAD) inputs = new Inputs();
-	//inputs->Marshall(marshallhandle);
-	_error_("not implemented");
+
+	/*Allocate memory if need be*/
+	int N = this->numids; _assert_(N>=0 && N<1e6);
+	if(marshallhandle->OperationNumber() == MARSHALLING_LOAD){
+		if(N){
+			this->inputs = xNew<Input*>(N);
+			for(int i=0;i<N;i++) this->inputs[i] = NULL;
+		}
+		else{
+			this->inputs = NULL;
+		}
+	}
+
+	/*Marshall!*/
+	if(marshallhandle->OperationNumber()!=MARSHALLING_LOAD){
+		for(int i=0;i<N;i++){
+			_assert_(this->inputs[i]);
+			object_enum = this->inputs[i]->ObjectEnum();
+			marshallhandle->call(object_enum);
+			this->inputs[i]->Marshall(marshallhandle);
+		}
+	}
+	else{
+		for(int i=0;i<N;i++){
+			marshallhandle->call(object_enum);
+
+			if(object_enum==TriaInputEnum){
+				TriaInput* triainput2=new TriaInput();
+				triainput2->Marshall(marshallhandle);
+				this->inputs[i]=triainput2;
+			}
+			else if(object_enum==PentaInputEnum){
+				PentaInput* pentainput2=new PentaInput();
+				pentainput2->Marshall(marshallhandle);
+				this->inputs[i]=pentainput2;
+			}
+			else if(object_enum==TransientInputEnum){
+				TransientInput* transinput2=new TransientInput();
+				transinput2->Marshall(marshallhandle);
+				this->inputs[i]=transinput2;
+			}
+			else{
+				_error_("input "<<EnumToStringx(object_enum)<<" not supported");
+			}
+		}
+	}
 
 }
Index: issm/trunk/src/c/classes/Inputs/Input.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/Input.h	(revision 25994)
+++ issm/trunk/src/c/classes/Inputs/Input.h	(revision 26744)
@@ -44,4 +44,5 @@
 
 		virtual void   AXPY(Input* xinput,IssmDouble scalar){_error_("Not implemented yet");};
+		virtual void   Shift(IssmDouble scalar){_error_("Not implemented yet");};
 		virtual void   PointWiseMult(Input* xinput){_error_("Not implemented yet");};
 		virtual void   Pow(IssmDouble scale_factor){_error_("Not implemented yet");};
